Bug 123577 - Kernel Panic with an Alcatel Speedtouch USB after invoking modem_run
Kernel Panic with an Alcatel Speedtouch USB after invoking modem_run
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
2
All Linux
medium Severity high
: ---
: ---
Assigned To: Arjan van de Ven
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-05-19 09:43 EDT by Eddahbi Karim
Modified: 2007-11-30 17:10 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-05-20 07:29:46 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Eddahbi Karim 2004-05-19 09:43:18 EDT
Description of problem:
The kernel provided with Fedora Core 2 seems to be like a 2.6.6.

And on 2.6.6 kernels, modem_run, the utility used to load the
Alcatel Speedtouch USB firmware, is buggy and think that the
ADSL Line goes down just after loading the firmware and tell
the kernel that the modem has been disconnected.

But the modem is still plugged in the computer.
Then, when you unplug the modem, the kernel will dereference a NULL
Pointer and create a Kernel Panic.

I'll report it to the LKML when I can.
This bug can reproduced on any distro with a 2.6.6 kernel (Tested on
Gentoo too)

Version-Release number of selected component (if applicable):
Kernel 2.6.5-1.358 (Fedora) or
Kernel 2.6.6 (Vanilla)

How reproducible:
Always

Steps to Reproduce:
1. Load a kernel 2.6.6 with Speedtouch USB support and plug the modem
in. Don't forget to get Speedtouch OpenSource utilities from Benoit
Papillaut. You can have them here : http://speedtouch.sourceforge.net
2. Then use modem_run like that :
modem_run -a bootcode -k -f firmware.bin

(The bootcode is given with the speedtouch utilities.
The firmware can be taken on the same website.)

Check the logs, the "monitoring report" utility of modem_run will tell
the kernel that the link goes up THEN down and the modem has been
disconnected (Unplugged).

3. Disconnect the modem.
  
Actual results:
Kernel Panic.

Expected results:
Modem_run shouldn't think that the modem has been disconnected.
This problem wasn't there on 2.6.5 vanilla kernels.

Additional info:

I have an unfamous VIA Motherboard and an Alcatel Speedtouch USB (The
green one. Not a Speedtouch 330)
Comment 1 Eddahbi Karim 2004-05-19 09:43:51 EDT
Here is the part that you should see in your /var/log/messages after
recreating this bug :

May 19 05:03:32 localhost modem_run[3019]: modem_run version 1.2
started by gamer uid 0
May 19 05:06:50 localhost modem_run[7407]: modem_run version 1.2
started by gamer uid 0
May 19 05:06:50 localhost kernel: usb 1-2: usbfs: interface 2 claimed
while 'modem_run' sets config #1
May 19 05:06:52 localhost kernel: usb 1-2: bulk timeout on ep5in
May 19 05:06:52 localhost kernel: usbfs: USBDEVFS_BULK failed dev 2 ep
0x85 len 512 ret -110
May 19 05:06:56 localhost kernel: usb 1-2: usbfs: interface 0 claimed
while 'modem_run' sets config #1
May 19 05:06:56 localhost kernel: usb 1-2: usbfs: interface 2 claimed
while 'modem_run' sets config #1
May 19 05:06:56 localhost modem_run[7407]: Kernel mode driver not found
May 19 05:07:08 localhost modem_run[7408]: [monitoring report] ADSL
link went up
May 19 05:07:26 localhost modem_run[7407]: ADSL synchronization has
been obtained
May 19 05:07:26 localhost modem_run[7407]: ADSL line is up (1248
kbit/s down | 160 kbit/s up)
May 19 05:07:26 localhost modem_run[7408]: Error reading interrupts
May 19 05:07:26 localhost modem_run[7408]: [monitoring report] ADSL
link went down
May 19 05:07:26 localhost modem_run[7408]: Device disconnected,
shutting down
May 19 05:07:26 localhost modem_run[7407]: pusb_release_interface 2 failed
May 19 05:07:54 localhost kernel: usb 1-2: USB disconnect, address 2
May 19 05:07:54 localhost kernel: Unable to handle kernel NULL pointer
dereference at virtual address 00000004
May 19 05:07:54 localhost kernel:  printing eip:
May 19 05:07:54 localhost kernel: 022183fa
May 19 05:07:54 localhost kernel: *pde = 00000000
May 19 05:07:54 localhost kernel: Oops: 0000 [#1]
May 19 05:07:54 localhost kernel: CPU:    0
May 19 05:07:54 localhost kernel: EIP:    0060:[<022183fa>]    Not tainted
May 19 05:07:54 localhost kernel: EFLAGS: 00010097   (2.6.5-1.358)
May 19 05:07:54 localhost kernel: EIP is at destroy_async+0x10/0x67
May 19 05:07:54 localhost kernel: eax: 15d58610   ebx: 00000202   ecx:
00000000   edx: 15d5862c
May 19 05:07:54 localhost kernel: esi: 15d5862c   edi: 15d58610   ebp:
0000000a   esp: 21e2df1c
May 19 05:07:54 localhost kernel: ds: 007b   es: 007b   ss: 0068
May 19 05:07:54 localhost kernel: Process khubd (pid: 5,
threadinfo=21e2d000 task=21f66030)
May 19 05:07:54 localhost kernel: Stack: 1f2d9954 022e2e60 1f2d9964
022117f5 1f2d9964 022e2e80 021d9628 022e28a0
May 19 05:07:54 localhost kernel:        022e28ec 021d9728 1f2d9964
022daae8 210ef4cc 021d8a96 1f2d9964 210ef400
May 19 05:07:54 localhost kernel:        ffffffff 021d8abf 00000001
02215fe4 210ef440 210ef400 0221212a 00000100
May 19 05:07:54 localhost kernel: Call Trace:
May 19 05:07:54 localhost kernel:  [<022117f5>]
usb_unbind_interface+0x2c/0x50
May 19 05:07:54 localhost kernel:  [<021d9628>]
device_release_driver+0x3c/0x46
May 19 05:07:54 localhost kernel:  [<021d9728>]
bus_remove_device+0x47/0x80
May 19 05:07:54 localhost kernel:  [<021d8a96>] device_del+0x66/0x87
May 19 05:07:54 localhost kernel:  [<021d8abf>] device_unregister+0x8/0x10
May 19 05:07:54 localhost kernel:  [<02215fe4>]
usb_disable_device+0x62/0x8a
May 19 05:07:54 localhost kernel:  [<0221212a>] usb_disconnect+0x9d/0xd2
May 19 05:07:54 localhost kernel:  [<0221396f>]
hub_port_connect_change+0x4b/0x210
May 19 05:07:54 localhost kernel:  [<02213c0a>] hub_events+0xd6/0x296
May 19 05:07:54 localhost kernel:  [<02213de8>] hub_thread+0x1e/0xd0
May 19 05:07:54 localhost kernel:  [<02115e97>]
default_wake_function+0x0/0xc
May 19 05:07:54 localhost kernel:  [<02213dca>] hub_thread+0x0/0xd0
May 19 05:07:54 localhost kernel:  [<021041d9>]
kernel_thread_helper+0x5/0xb
May 19 05:07:54 localhost kernel:
May 19 05:07:54 localhost kernel: Code: 8b 51 04 8b 01 89 50 04 89 02
89 49 04 89 09 53 9d 8b 41 20
Comment 2 Dave Jones 2004-05-19 20:10:08 EDT
There was a slew of USB fixes recently, try the latest kernel from
http://people.redhat.com/arjanv/2.6/RPMS.kernel/
Comment 3 Eddahbi Karim 2004-05-20 01:45:24 EDT
Ok this works for modem_run, the crash has been solved. Thanks ;)

Note You need to log in before you can comment on or make changes to this bug.